"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const ws = require("ws");
const types = require("./types-BA1Jqeol.cjs");
async function CreateServer(contract, options) {
  const websocket = new ws.WebSocketServer(options);
  const methods = contract;
  websocket.addListener("connection", (client) => client.on("message", async (data) => {
    try {
      const request = JSON.parse(data.toString("utf8"));
      const { method, reference, parameters } = request;
      let response;
      try {
        if (method in methods) {
          const result = await methods[method](...parameters) ?? null;
          response = { type: types.MessageType.Callback, reference, result };
        } else {
          throw new Error(`The method '${method}' is not registered!`);
        }
      } catch (err) {
        const error = err;
        response = { type: types.MessageType.Callback, reference, error: { name: error.name, message: error.message, stack: error.stack } };
      }
      client.send(JSON.stringify(response));
    } catch (error) {
    }
  }));
  return websocket;
}
exports.CreateServer = CreateServer;
