import { WebSocketServer } from "ws";
import { M as MessageType } from "./types-BAoxzGM5.js";
async function CreateServer(contract, options) {
  const websocket = new WebSocketServer(options);
  const methods = contract;
  websocket.addListener("connection", (client) => client.on("message", async (data) => {
    try {
      const request = JSON.parse(data.toString("utf8"));
      const { method, reference, parameters } = request;
      let response;
      try {
        if (method in methods) {
          const result = await methods[method](...parameters) ?? null;
          response = { type: MessageType.Callback, reference, result };
        } else {
          throw new Error(`The method '${method}' is not registered!`);
        }
      } catch (err) {
        const error = err;
        response = { type: MessageType.Callback, reference, error: { name: error.name, message: error.message, stack: error.stack } };
      }
      client.send(JSON.stringify(response));
    } catch (error) {
    }
  }));
  return websocket;
}
export {
  CreateServer
};
